#ifndef FILESYS_H
#define FILESYS_H

#ifdef WIN32
#include <windows.h>
#define MAX_PATH_LEN MAX_PATH
#elif LINUX
#include <dirent.h>
#define MAX_PATH_LEN 4096
#endif

#define FS_FILE 0
#define FS_DIR 1
#define FS_OTHER 2

struct dir_listing
{
#ifdef WIN32
	WIN32_FIND_DATA find_data;
	HANDLE handle;
	int end_of_listing;
#elif LINUX
	DIR *dir;
#endif
};

int dir_listing_co(struct dir_listing *self, const char *path);
void dir_listing_de(struct dir_listing *self);
int dir_listing_get_next(struct dir_listing *self, int *type, char *name, unsigned int maxlen);

#endif

