#include "gfx.h"

void gfx_draw_rect_8bit(SDL_Surface *s, SDL_Rect r, Uint8 c)
{
	Uint16 ix, iy;
	if(r.x<0){
		r.w += r.x;
		r.x = 0;
	}
	if(r.x + r.w >= s->w){
		r.w = s->w - r.x;
	}
	if(r.y<0){
		r.h += r.y;
		r.y = 0;
	}
	if(r.y + r.h >= s->h){
		r.h = s->h - r.y;
	}
	for(iy=0; iy<r.h; iy++){
		Uint8 *p = (Uint8 *)s->pixels + r.x + s->pitch*(iy+r.y);
		for(ix=0; ix<r.w; ix++){
			*p = c;
			p++;
		}
	}
}

void gfx_draw_horizontal_line_8bit(SDL_Surface *s, int x, int y, int l, Uint8 c)
{
	if(y<0 || y >= s->h) return;
	if(x+l<0 || x >= s->w) return;
	if(x<0){ l+=x; x=0; }
	if(x+l >= s->w) l = s->w - x;
	Uint8 *p = (Uint8*)s->pixels + s->pitch*y + x;
	unsigned int i;
	for(i=0; i<l; i++){
		*p = c;
		p++;
	}
}
void gfx_draw_vertical_line_8bit(SDL_Surface *s, int x, int y, int l, Uint8 c)
{
	if(x<0 || x >= s->w) return;
	if(y+l<0 || y >= s->h) return;
	if(y<0){ l+=y; y=0; }
	if(y+l >= s->h) l = s->h - y;
	Uint8 *p = (Uint8*)s->pixels + s->pitch*y + x;
	unsigned int i;
	for(i=0; i<l; i++){
		*p = c;
		p+=s->pitch;
	}
}
void gfx_draw_selection_cursor(SDL_Surface *s, SDL_Rect r, Uint8 c)
{
	int w = r.w;
	int h = r.h;
	if(w<4 || h<4) return;
	int x = r.x;
	int y = r.y;
	int w1 = w / 4;
	int h1 = w / 4;
	//precalculating these makes it a bit faster (9.65us->9.25us)
	int x1 = x+w-2;
	int y1 = y+h-2;
	int x2 = x+w-w1-1;
	int y2 = y+h-h1-1;
	int h1s = h1-2;
	//fprintf(stderr, "x=%i y=%i w=%i h=%i w1=%i h1=%i x1=%i y1=%i x2=%i y2=%i h1s=%i\n",
	//		x, y, w, h, w1, h1, x1, y1, x2, y2, h1s);
	gfx_draw_horizontal_line_8bit(s, x,    y,    w1,  c);
	gfx_draw_horizontal_line_8bit(s, x,    y+1,  w1,  c);
	gfx_draw_horizontal_line_8bit(s, x2,   y,    w1,  c);
	gfx_draw_horizontal_line_8bit(s, x2,   y+1,  w1,  c);
	gfx_draw_horizontal_line_8bit(s, x,    y1-1, w1,  c);
	gfx_draw_horizontal_line_8bit(s, x,    y1,   w1,  c);
	gfx_draw_horizontal_line_8bit(s, x2,   y1-1, w1,  c);
	gfx_draw_horizontal_line_8bit(s, x2,   y1,   w1,  c);
	gfx_draw_vertical_line_8bit  (s, x,    y+2,  h1s, c);
	gfx_draw_vertical_line_8bit  (s, x+1,  y+2,  h1s, c);
	gfx_draw_vertical_line_8bit  (s, x,    y2,   h1s, c);
	gfx_draw_vertical_line_8bit  (s, x+1,  y2,   h1s, c);
	gfx_draw_vertical_line_8bit  (s, x1-1, y+2,  h1s, c);
	gfx_draw_vertical_line_8bit  (s, x1,   y+2,  h1s, c);
	gfx_draw_vertical_line_8bit  (s, x1-1, y2,   h1s, c);
	gfx_draw_vertical_line_8bit  (s, x1,   y2,   h1s, c);
}
/*void gfx_draw_line_8bit(SDL_Surface *s, int x1, int y1, int x2, int y2, Uint8 c)
{
}*/

