#ifndef IMGLIB_H
#define IMGLIB_H

#include <SDL/SDL.h>

#define STORED_IMAGES_MAX_COUNT 100

struct stored_img
{
	SDL_Surface *s;
	char *name;
};

int stored_img_co(struct stored_img *self);
void stored_img_de(struct stored_img *self);
int stored_img_load_bmp(struct stored_img *self, const char *path, SDL_PixelFormat *screenfmt, Uint32 screenflags, Uint32 colorkey);

struct imglib
{
	struct stored_img images[STORED_IMAGES_MAX_COUNT];
	SDL_PixelFormat *screenfmt;
	Uint32 screenflags;
	Uint32 colorkey;
	int format_set;
};


int imglib_co(struct imglib *self);
void imglib_de(struct imglib *self);
void imglib_set_format(struct imglib *self, SDL_PixelFormat *screenfmt, Uint32 screenflags, Uint32 colorkey);
int imglib_load(struct imglib *self, const char *path);
//struct stored_img * imglib_get_stored_image(struct imglib *self, const char *name);
SDL_Surface * imglib_get_image(struct imglib *self, const char *name);

#endif

